﻿using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Net;
using System.Net.Sockets;
using System.Threading;
using System.Drawing;
using System.Windows.Forms;
namespace CCTVServer
{
    public class MiniServer
    {
        private readonly int port;
        private volatile bool working;
        private readonly Form1 form1;
        private TcpListener listener;
        public MiniServer(int port, Form1 form1)
        {
            this.port = port;
            this.form1 = form1;
        }

        public void Start()
        {
            working = true;
            Thread serverThread = new Thread(new ThreadStart(serverLoop));
            serverThread.Name = "serverThread";
            serverThread.IsBackground = true;
            serverThread.Start();

        }
        public void Stop()
        {
            working = false;
            listener.Stop();
        }
        private void serverLoop()
        {
            listener = new TcpListener(IPAddress.Any, port);
            listener.Start();
            while (working)
            {
                try
                {
                    TcpClient client = listener.AcceptTcpClient();
                    Thread c = new Thread(new ParameterizedThreadStart(clientLoop));
                    c.IsBackground = true;
                    c.Name = "client";
                    c.Start(client);
                }
                catch (Exception e)
                {
                    Console.WriteLine(e.ToString());
                }
                Thread.Sleep(1000);
            }
            
        }
        private void clientLoop(object client)
        {
            Console.WriteLine("starting clientLoop");
            TcpClient tcp = (TcpClient)client;
            Stream stream = tcp.GetStream();
            BinaryReader br = new BinaryReader(stream);
            byte[] buffer = new byte[8192];

            while (working)
            {
                try
                {
                    if (tcp.Connected == false)
                        break;
                    int size = br.ReadInt32();
                    MemoryStream ms = new MemoryStream(size);

                    while (size > 0)
                    {
                        int count = stream.Read(buffer, 0, Math.Min(size, buffer.Length));
                        if (count <= 0)
                            break;
                        ms.Write(buffer, 0, count);
                        size -= count;
                    }
                    ms.Position = 0;
                    Bitmap bmp = new Bitmap(ms);
                    MethodInvoker mi = delegate()
                    {
                        form1.pictureBox1.Image = bmp;
                    };
                    form1.BeginInvoke(mi);
                }
                catch (Exception e)
                {
                    Console.WriteLine(e.ToString());
                    break;
                }
            }
            stream.Close();
            tcp.Close();
        }
    }
}
